//
//  ViewController.m
//  Scrollview练习
//
//  Created by Hero11223 on 16/5/11.
//  Copyright © 2016年 zyy. All rights reserved.
//

#define FRAME [[UIScreen mainScreen] bounds]
#define WIDTH  FRAME.size.width
#define HEIGHT FRAME.size.height
#define mainTone [UIColor colorWithRed:73.0/255.0 green:196.0/255.0 blue:51.0/255.0 alpha:1.0]//导航颜色
#define NavigationHeight 64.0 //tabBar的高度

#import "ViewController.h"
#import "Hcell.h"

@interface ViewController ()<UITableViewDelegate,UITableViewDataSource,UIScrollViewDelegate>
{
    UIScrollView *_bigScrollview;
    
    NSMutableArray *array1;
    NSMutableArray *array2;
    NSMutableArray *array3;
    NSMutableArray *array4;
    
    UIView *_topView;
    UIView *_selectedView;
    UIButton *_selectedBtn;
}

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    self.view.backgroundColor = [UIColor redColor];
    
    array1 = [NSMutableArray arrayWithObjects:@"a",@"a",@"b",@"c",@"d", nil];
    array2 = [NSMutableArray arrayWithObjects:@"1",@"2",@"3",@"4",@"5", nil];
    array3 = [NSMutableArray arrayWithObjects:@"-",@"=",@"+",@"/",@">", nil];
    array4 = [NSMutableArray arrayWithObjects:@"一",@"起",@"走",@"永",@"远", nil];
    
    [self initTopView];
    [self initUI];
}

-(void)initTopView
{
    float topScrollHeight = 64;
    _topView = [[UIView alloc]initWithFrame:CGRectMake(0, 64, WIDTH, topScrollHeight)];
    [_topView setBackgroundColor:[UIColor whiteColor]];
    [self.view addSubview:_topView];
    NSArray *array = [[NSArray alloc]initWithObjects:@"同学",@"老师",@"校内",@"校外", nil];
    float width = WIDTH/array.count;
    _selectedView = [[UIView alloc]initWithFrame:CGRectMake(0, 64*2-3, width, 1)];
    _selectedView.backgroundColor = mainTone;
    [self.view addSubview:_selectedView];
    for (int i = 0; i<array.count; i++) {
        NSString *title = [array objectAtIndex:i];
        UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
        btn.frame = CGRectMake(width*i,0 , width, topScrollHeight);
        [btn setTitle:title forState:UIControlStateNormal];
        [btn setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        [btn setTitleColor:mainTone forState:UIControlStateSelected];
        [btn addTarget:self action:@selector(topBtnClick:) forControlEvents:UIControlEventTouchUpInside];
        btn.tag = 100+i;
        [_topView addSubview:btn];
        if (i==0) {
            _selectedBtn = btn;
            _selectedBtn.selected = YES;
        }
    }

}

-(void)initUI
{
    _bigScrollview = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 64*2, WIDTH, HEIGHT)];
    _bigScrollview.contentSize = CGSizeMake(WIDTH *4, 0);
    _bigScrollview.backgroundColor = [UIColor grayColor];
    _bigScrollview.pagingEnabled = YES;
    _bigScrollview.bounces = NO;
    _bigScrollview.delegate = self;
    [self.view addSubview:_bigScrollview];
    
    for (int i = 0; i<4; i++) {
        UITableView *tableView = [[UITableView alloc]initWithFrame:CGRectMake(WIDTH *i, 0, WIDTH, _bigScrollview.frame.size.height) style:UITableViewStylePlain];
        tableView.tag = i+200;
        tableView.delegate = self;
        tableView.dataSource = self;
        tableView.tableFooterView = [[UIView alloc]init];
        [_bigScrollview addSubview:tableView];
        
    }
    
}

#pragma  mark--scrollViewDelegate
-(void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView
{
    if ([scrollView isEqual:_bigScrollview]) {
        int contentoffset = scrollView.contentOffset.x;
        int numOfTable = contentoffset/WIDTH;
        UIButton *btn = (UIButton *)[self.view viewWithTag:100+numOfTable];
        [self topBtnClick:btn];
    }
}
- (void)scrollViewDidScroll:(UIScrollView *)scrollView{
    if (scrollView.contentOffset.y<0) {
        return;
    }
}

- (void)scrollViewDidEndDragging:(UIScrollView *)scrollView willDecelerate:(BOOL)decelerate{
    if (scrollView.contentOffset.y<0) {
        return;
    }
}

-(void)topBtnClick:(UIButton *)sender
{
    if (_selectedBtn == sender) {
        return;
    }
    _selectedBtn.selected = NO;
    _selectedBtn = sender;
    _selectedBtn.selected = YES;
    
    float width = WIDTH/4;
    [_bigScrollview setContentOffset:CGPointMake(WIDTH*(sender.tag-100), 0) animated:YES];
    [UIView animateWithDuration:0.3 animations:^{
        _selectedView.frame = CGRectMake(width*(sender.tag-100), 64*2-3, width, 1);
    }];
    
}


-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    switch (tableView.tag-200) {
        case 0:
        {
            return array1.count;
        }
            break;
        case 1:
        {
            return array2.count;
        }
            break;
        case 2:
        {
            return array3.count;
        }
            break;
        case 3:
        {
            return array4.count;
        }
            break;
        default:
            return 0;
            break;
    }
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *cellidefierCell = @"CELLS";
//    UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
    Hcell *cell = [tableView cellForRowAtIndexPath:indexPath];
    if (!cell) {
        
//        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellidefierCell];
        cell = [[Hcell alloc]initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellidefierCell];
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        
    }
    
    switch (tableView.tag-200) {
        case 0:
        {
//            cell.textLabel.text = array1[indexPath.row];
            cell.textLab.text = array1[indexPath.row];
        }
            break;
        case 1:
        {
//            cell.textLabel.text = array2[indexPath.row];
            cell.textLab.text = array2[indexPath.row];
        }
            break;
        case 2:
        {
//            cell.textLabel.text = array3[indexPath.row];
            cell.textLab.text = array3[indexPath.row];
        }
            break;
        case 3:
        {
            cell.textLab.text = array4[indexPath.row];
        }
            break;
        default:
            break;
    }
    
    return cell;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
